
#include <MySigningNone.h>
#include <MyTransportNRF24.h>
#include <MyHwATMega328.h>
#include <MySensor.h>
#include <SPI.h>
#include <Bounce2.h>

//char sketch_name[] = "Multy-Relay";
//char sketch_ver[]  = "1.1";

#define RELAY_ON 1  // switch around for realy HIGH/LOW state
#define RELAY_OFF 0
//#define DEBUG On

MySensor gw;

#define RADIO_ID 45 // Id ноды, независимо от того, какой канал вы назначили
#define noRelays 2
const int relayPin[] = {3,4}; //  Переключайте контакты по своему желанию
const int buttonPin[] = {6,7}; //  Переключайте контакты по своему желанию

class Relay // Класс реле, хранить все релевантные данные (эквивалентные структуре)
{
public: 
  int buttonPin;                    // physical pin number of button
  int relayPin;                     // physical pin number of relay
  byte oldValue;                    // last Values for key (debounce)
  boolean loadState;               // Состояние реле (также сохраняется в EEPROM)
};

Relay Relays[noRelays];
Bounce debouncer[noRelays];
MyMessage msg[noRelays];

void setup()
{
  gw.begin(incomingMessage, RADIO_ID, true);
  delay(500);
  gw.sendSketchInfo("Multy-Switch-Relay", "1.1");
  delay(500);

  // Инициализировать реле и соответствующие кнопки
  for (int i = 0; i < noRelays; i++)
  {
    Relays[i].buttonPin = buttonPin[i]; // Назначить физические контакты
    Relays[i].relayPin = relayPin[i];
    msg[i].sensor = i;  // Инициализировать сообщения
    msg[i].type = V_LIGHT;
    debouncer[i] = Bounce();  // Инициализировать debouncer
    debouncer[i].attach(buttonPin[i]);
    debouncer[i].interval(5);
    pinMode(Relays[i].buttonPin, INPUT_PULLUP);
    pinMode(Relays[i].relayPin, OUTPUT);
    Relays[i].loadState = gw.loadState(i); // Извлечь последние значения из EEPROM
    digitalWrite(Relays[i].relayPin, Relays[i].loadState ? RELAY_ON : RELAY_OFF); // И соответственно установить реле
    gw.send(msg[i].set(Relays[i].loadState ? true : false)); // Информировать шлюз о последнем статусе
    gw.present(i, V_LIGHT); // Представить датчик на шлюз
    delay(250);
  }
}

void loop()
{
  gw.process();
  
  for (byte i = 0; i < noRelays; i++)  {
    debouncer[i].update();
    byte value = debouncer[i].read();
    if (value != Relays[i].oldValue && value == 0)
    //if (value != Relays[i].oldValue)
    {
      Relays[i].loadState = !Relays[i].loadState;
      gw.send(msg[i].set(Relays[i].loadState ? true : false));
      digitalWrite(Relays[i].relayPin, Relays[i].loadState ? RELAY_ON : RELAY_OFF);
      gw.saveState( i, Relays[i].loadState ); // Сохранить состояние датчика в EEPROM (положение == номер датчика)
    }
    Relays[i].oldValue = value;
  }
}

// Обрабатывать входящие сообщения
void incomingMessage(const MyMessage &message)
{
  if (message.type == V_LIGHT)
  {
    if (message.sensor < noRelays)  // Проверить, действительно ли сообщение для реле ..... предыдущая строка  [[[ if (message.sensor <=noRelays){ ]]]
    {
      Relays[message.sensor].loadState = message.getBool();
      digitalWrite(Relays[message.sensor].relayPin, Relays[message.sensor].loadState ? RELAY_ON : RELAY_OFF); // И соответственно настройте реле
      gw.saveState( message.sensor, Relays[message.sensor].loadState ); // Сохранить состояние датчика в EEPROM (положение == номер датчика)
    }
  }
}
